import java.awt.Checkbox;
import java.awt.List;
import java.awt.Panel;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.Vector;

/**
 *  ,  
 */
public class ElevatorLog 
	extends Panel 
	implements ElevatorLogInterface, ItemListener
{
	protected boolean logBegin;
	protected boolean logTrans;
	protected boolean logEnd;
	protected boolean logInput;
	protected boolean logAction;
	protected Vector logAut;
	
	protected int HEIGHT;
	final static int HEIGHT_DEFAULT = 410;

	protected List logList = new List();
	protected Checkbox chLogBegin, chLogEnd, chLogTrans, chLogInput,
		chLogAction, chLogA0, chLogA1, chLogA2, chLogA11, chLogA21,
		chLogA22, chLogA32;
	protected ElevatorApplet mainApplet;
	
	ElevatorLog( ElevatorApplet appl )
	{
		mainApplet = appl;
		HEIGHT = mainApplet.getParamInt( "LOG_HEIGHT", 
										 HEIGHT_DEFAULT );
		setSize( 450, HEIGHT );
		setLayout( null );
		logList.setBounds( 0, 0, 450, HEIGHT-100 );
		add( logList );
		chLogBegin = new Checkbox( " " );
		chLogBegin.setBounds( 10, HEIGHT-100, 200, 20 );
		chLogBegin.addItemListener( this );
		add( chLogBegin );
		chLogTrans = new Checkbox( "  " );
		chLogTrans.setBounds( 10, HEIGHT-80, 200, 20 );
		chLogTrans.addItemListener( this );
		add( chLogTrans );
		chLogEnd = new Checkbox( "  " );
		chLogEnd.setBounds( 10, HEIGHT-60, 200, 20 );
		chLogEnd.addItemListener( this );
		add( chLogEnd );
		chLogInput = new Checkbox( "  " );
		chLogInput.setBounds( 10, HEIGHT-40, 200, 20 );
		chLogInput.addItemListener( this );
		add( chLogInput );
		chLogAction = new Checkbox( " " );
		chLogAction.setBounds( 10, HEIGHT-20, 200, 20 );
		chLogAction.addItemListener( this );
		add( chLogAction );
		chLogA11 = new Checkbox( "A11" );
		chLogA11.setBounds( 220, HEIGHT-100, 40, 20 );
		chLogA11.addItemListener( this );
		add( chLogA11 );
		chLogA21 = new Checkbox( "A21" );
		chLogA21.setBounds( 220, HEIGHT-80, 40, 20 );
		chLogA21.addItemListener( this );
		add( chLogA21 );
		chLogA22 = new Checkbox( "A22" );
		chLogA22.setBounds( 220, HEIGHT-60, 40, 20 );
		chLogA22.addItemListener( this );
		add( chLogA22 );
		chLogA32 = new Checkbox( "A32" );
		chLogA32.setBounds( 220, HEIGHT-40, 40, 20 );
		chLogA32.addItemListener( this );
		add( chLogA32 );
		chLogA0 = new Checkbox( "A0" );
		chLogA0.setBounds( 270, HEIGHT-100, 40, 20 );
		chLogA0.addItemListener( this );
		add( chLogA0 );
		chLogA1 = new Checkbox( "A1" );
		chLogA1.setBounds( 270, HEIGHT-80, 40, 20 );
		chLogA1.addItemListener( this );
		add( chLogA1 );
		chLogA2 = new Checkbox( "A2" );
		chLogA2.setBounds( 270, HEIGHT-60, 40, 20 );
		chLogA2.addItemListener( this );
		add( chLogA2 );
		logAut = new Vector();
	}

	/**
	 *    " "
	 */
	public void itemStateChanged( ItemEvent e )
	{
		boolean enable = ((Checkbox)e.getSource()).getState();
		if ( e.getSource().equals( chLogBegin ) )
		{
			log( "  : " +
				 enable );
			logBegin = enable;
		}
		else if ( e.getSource().equals( chLogTrans ) )
		{
			log( "   : " +
				 enable );
			logTrans = enable;
		}
		else if ( e.getSource().equals( chLogEnd ) )
		{
			log( "   : " +
				 enable );
			logEnd = enable;
		}
		else if ( e.getSource().equals( chLogInput ) )
		{
			log( "   : " +
				 enable );
			logInput = enable;
		}
		else if ( e.getSource().equals( chLogAction ) )
		{
			log( "  : " +
				 enable );
			logAction = enable;
		}
		else if ( e.getSource().equals( chLogA0 ) )
			logAutChange( 0, enable );
		else if ( e.getSource().equals( chLogA1 ) )
			logAutChange( 1, enable );
		else if ( e.getSource().equals( chLogA2 ) )
			logAutChange( 2, enable );
		else if ( e.getSource().equals( chLogA11 ) )
			logAutChange( 11, enable );
		else if ( e.getSource().equals( chLogA21 ) )
			logAutChange( 21, enable );
		else if ( e.getSource().equals( chLogA22 ) )
			logAutChange( 22, enable );
		else if ( e.getSource().equals( chLogA32 ) )
			logAutChange( 32, enable );
	}

	/**
	 *   
	 */
	public void error( int aut, String err )
	{
		write( "! A" + aut + ": : " + err );
	}
	
	/**
	 *   
	 */
	public void begin( int aut, int state, int event )
	{
		if ( logBegin )
			aut( aut, "{ A" + aut + ":   " + state + 
					  "    e" + event );
	}
	
	/**
	 *   
	 */
	public void trans( int aut, int old_state, int new_state )
	{
		if ( logTrans )
			aut( aut, "T A" + aut + ":    " + 
					  old_state + "   " + new_state );
	}
	
	/**
	 *   
	 */
	public void end( int aut, int state, int event )
	{
		if ( logEnd )
			aut( aut, "} A" + aut + ":    e" +
					  event + "   " + state );
	}
	
	/**
	 *   
	 */
	public void input( int num, String str, boolean ret )
	{
		if ( logInput )
			write( "> x" + num + " - " + str + " -  " + ret );
	}
	
	/**
	 *  
	 */
	public void action( int num, String str )
	{
		if ( logAction )
			write( "* z" + num + " - "  + str );
	}
	
	/**
	 *    
	 */
	public void log( String str )
	{
		write( "# " + str );
	}
	
	protected void write( String str )
	{
		Calendar cal = new GregorianCalendar();
		String hr = "" + cal.get( Calendar.HOUR_OF_DAY );
		while ( hr.length() < 2 ) { hr = "0" + hr; }
		String mn = "" + cal.get( Calendar.MINUTE );
		while ( mn.length() < 2 ) { mn = "0" + mn; }
		String sc = "" + cal.get( Calendar.SECOND );
		while ( sc.length() < 2 ) { sc = "0" + sc; }
		String ms = "" + cal.get( Calendar.MILLISECOND );
		while ( ms.length() < 3 ) { ms = "0" + ms; }
		logList.add( hr + ":" + mn + ":" + sc + "." + ms + " " + 
					 str );
		logList.makeVisible( logList.getItemCount()-1 );
	}
	
	protected void aut( int aut, String str )
	{
		if ( logAut.contains( new Integer( aut ) ) )
			write( str );
	}
	
	protected void logAutChange( int aut, boolean enable )
	{
		log( "  A" + aut + ": " + enable );
		Integer a = new Integer( aut );
		if ( enable )
		{
			if ( !logAut.contains( a ) )
				logAut.addElement( a );
		}
		else
		{
			logAut.removeElement( a );
		}
	}
	
}
