import java.applet.Applet;
import java.awt.Color;
import java.awt.Canvas;
import java.awt.Graphics;
import java.awt.List;
import java.awt.MediaTracker;
import java.awt.Image;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Vector;

/**
 *     
 */
public class ElevatorVisualizer
	extends Canvas
	implements ElevatorVisualizerInterface, MouseListener, Runnable
{
	final static int DELAY_DEFAULT = 50;
	protected int DELAY;
	final static int DOORS_TIMER_MAX_DEFAULT = 30;
	protected int DOORS_TIMER_MAX;
	final static int DOORS_MAX_DEFAULT = 30;
	protected int DOORS_MAX;
	final static int DOORS_MOVE_DEFAULT = 2;
	protected int DOORS_MOVE;
	final static int ELEVATOR_MOVE_DEFAULT = 2;
	protected int ELEVATOR_MOVE;
	final static int ELEVATOR_1_FLOOR = 0;
	final static int ELEVATOR_2_FLOOR = 100;
	final static int ELEVATOR_3_FLOOR = 200;
	protected Vector events = new Vector();
	protected int doorsPosition = 0;
	protected int elevatorPosition = 0;
	protected int doorsMove = 0;
	protected int elevatorMove = 0;
	protected boolean isLampOn;
	protected int doorsTimer = -1;
	protected int panelState = 0;
	protected boolean xx51;
	protected boolean zz11, zz21, zz22, zz32;
	protected ElevatorApplet mainApplet;
	protected Image imBackground,
		imElevatorWallPaper,
		imElevatorDoor,
		imMan,
		imSkeleton,
		imLampOff,
		imLampOn,
		imDoorsTimer,
		im3DownOn,
		im2UpOn,
		im2DownOn,
		im1UpOn,
		imPanel0,
		imPanel1,
		imPanel2,
		imPanel3,
		imPanelS,
		imGoLeft,
		imGoRight;
	
	protected ElevatorLogInterface log;
	protected ElevatorAutomats aut;
	
	ElevatorVisualizer( ElevatorApplet appl,
						ElevatorLogInterface log )
	{
		mainApplet = appl;
		setSize( 370, 310 );
		addMouseListener( this );
		aut = new ElevatorAutomats( this, log );
		this.log = log;
		DELAY = mainApplet.getParamInt( "DELAY", DELAY_DEFAULT );
		DOORS_TIMER_MAX = mainApplet.getParamInt( "DOORS_TIMER_MAX",
											DOORS_TIMER_MAX_DEFAULT );
		DOORS_MAX = mainApplet.getParamInt( "DOORS_MAX",
											DOORS_MAX_DEFAULT );
		DOORS_MOVE = mainApplet.getParamInt( "DOORS_MOVE",
											DOORS_MOVE_DEFAULT );
		ELEVATOR_MOVE = mainApplet.getParamInt( "ELEVATOR_MOVE",
											ELEVATOR_MOVE_DEFAULT );

		//   
		MediaTracker t = new MediaTracker( this );
		imBackground = mainApplet.getImage( 
								mainApplet.getDocumentBase(),
								"Background.gif" );
		t.addImage( imBackground, 0 );
		imElevatorWallPaper = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"ElevatorWallPaper.gif" );
		t.addImage( imElevatorWallPaper, 0 );
		imElevatorDoor = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"ElevatorDoor.gif" );
		t.addImage( imElevatorDoor, 0 );
		imMan = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"Man.gif" );
		t.addImage( imMan, 0 );
		imSkeleton = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"Skeleton.gif" );
		t.addImage( imSkeleton, 0 );
		imLampOff = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"LampOff.gif" );
		t.addImage( imLampOff, 0 );
		imLampOn = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"LampOn.gif" );
		t.addImage( imLampOn, 0 );
		imDoorsTimer = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"DoorsTimer.gif" );
		t.addImage( imDoorsTimer, 0 );
		im3DownOn = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"3DownOn.gif" );
		t.addImage( im3DownOn, 0 );
		im2UpOn = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"2UpOn.gif" );
		t.addImage( im2UpOn, 0 );
		im2DownOn = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"2DownOn.gif" );
		t.addImage( im2DownOn, 0 );
		im1UpOn = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"1UpOn.gif" );
		t.addImage( im1UpOn, 0 );
		imPanel0 = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"Panel0.gif" );
		t.addImage( imPanel0, 0 );
		imPanel1 = mainApplet.getImage(
								mainApplet.getDocumentBase(), 
								"Panel1.gif" );
		t.addImage( imPanel1, 0 );
		imPanel2 = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"Panel2.gif" );
		t.addImage( imPanel2, 0 );
		imPanel3 = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"Panel3.gif" );
		t.addImage( imPanel3, 0 );
		imPanelS = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"PanelS.gif" );
		t.addImage( imPanelS, 0 );
		imGoLeft = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"GoLeft.gif" );
		t.addImage( imGoLeft, 0 );
		imGoRight = mainApplet.getImage(
								mainApplet.getDocumentBase(),
								"GoRight.gif" );
		t.addImage( imGoRight, 0 );
		try
		{
			t.waitForID( 0 );
		}
		catch ( InterruptedException e )
		{
		}
	}

	/**
	 *   " "
	 */
	public void mousePressed( MouseEvent e )
	{
		int x = e.getX();
		int y = e.getY();
		if ( x>=111 && x<=143 && y>=64 && y<=96 )
			addEvent( 32 );
		else if ( x>=111 && x<=143 && y>=108 && y<=140 )
			addEvent( 21 );
		else if ( x>=111 && x<=143 && y>=168 && y<=200 )
			addEvent( 22 );
		else if ( x>=111 && x<=143 && y>=211 && y<=243 )
			addEvent( 11 );
		else if ( x>=297 && x<=332 && y>=23  && y<=58 )
			addEvent( 43 );
		else if ( x>=297 && x<=332 && y>=61  && y<=96 )
			addEvent( 42 );
		else if ( x>=297 && x<=332 && y>=100  && y<=135 )
			addEvent( 41 );
		else if ( x>=297 && x<=332 && y>=138  && y<=173 )
			addEvent( 44 );
		else if ( x>=177 && x<=242 && y>=238  && y<=288 )
			addEvent( 51 );
		else if ( x>=291 && x<=356 && y>=233  && y<=283 )
			addEvent( 50 );
	}
	public void mouseReleased( MouseEvent e ) {}
	public void mouseClicked( MouseEvent e ) {}
	public void mouseEntered( MouseEvent e ) {}
	public void mouseExited( MouseEvent e ) {}
	
	public void update( Graphics g )
	{
		paint( g );
	}

	/**
	 *   
	 */
	public void paint( Graphics g0  )
	{
		Image im = createImage( 370, 310 );
		Graphics g = im.getGraphics();

		g.drawImage( imBackground, 0, 0, this );
		if ( doorsPosition > 0 )
		{
			g.drawImage( imElevatorWallPaper,
						 3, 202 - elevatorPosition, this );
			if ( xx51 )
			{
				g.drawImage( imMan, 
							 25, 210 - elevatorPosition, this );
				g.drawImage( imGoRight, 295, 235, this );
			} 
			else
				g.drawImage( imGoLeft, 179, 209, this );
		}
		g.drawImage( imElevatorDoor, 
					 3, 202 - elevatorPosition, 
					 44 - doorsPosition, 303 - elevatorPosition, 
					 doorsPosition, 0, 40, 101, this );
		g.drawImage( imElevatorDoor,
					 44 + doorsPosition, 202 - elevatorPosition,
					 85, 303 - elevatorPosition,
					 0, 0, 40 - doorsPosition, 101, this );
		g.drawImage( imSkeleton, 0, 0, this );
		if ( isLampOn )
		{
			g.drawImage( imLampOn, 200, 10, this );
			switch ( panelState )
			{
			case 0:
				g.drawImage( imPanel0, 280, 13, this );
				break;
			case 1:
				g.drawImage( imPanel1, 280, 13, this );
				break;
			case 2:
				g.drawImage( imPanel2, 280, 13, this );
				break;
			case 3:
				g.drawImage( imPanel3, 280, 13, this );
				break;
			case 4:
				g.drawImage( imPanelS, 280, 13, this );
				break;
			}
		}
		else
		{
			g.drawImage( imLampOff, 200, 10, this );
			g.drawImage( imPanel0, 280, 13, this );
		}
		if ( doorsTimer >-1 )
		{
			g.drawImage( imDoorsTimer, 170, 110, this );
			g.setColor( new Color( 127, 200, 127 ) );
			g.fillArc( 197, 147, 47, 47, 
					   90, 360*doorsTimer/DOORS_TIMER_MAX );
		}
		if ( zz11 )
			g.drawImage( im1UpOn, 113, 214, this );
		if ( zz21 )
			g.drawImage( im2UpOn, 113, 112, this );
		if ( zz22 )
			g.drawImage( im2DownOn, 113, 174, this );
		if ( zz32 )
			g.drawImage( im3DownOn, 113, 70, this );

		g0.drawImage( im, 0, 0, this );
	}
	
	/**
	 *    
	 */
	public void run()
	{
		while ( true )
		{
//   
			int ev = getNextEvent();

			//  
			switch ( ev )
			{
			case 11:
				aut.A11( 11 );	//  A11   11
				break;

			case 21:
				aut.A21( 21 );
				break;

			case 22:
				aut.A22( 22 );
				break;

			case 32:
				aut.A32( 32 );
				break;

			case 41:
			case 42:
			case 43:
			case 44:
				if ( isLampOn )
					aut.A2( ev );
				break;

			case 50:
			case 51:
				if ( doorsPosition > 0 )
					xx51 = ( ev == 51 );
				break;
			}

			//   ,  
			if ( doorsTimer >-1 )
				doorsTimer--;
			if ( doorsTimer == 0 )
				aut.A0( 90 );
			boolean flag = doorsPosition > 0 && 
						   doorsPosition < DOORS_MAX ;
			doorsPosition += doorsMove;
			if ( flag && doorsPosition == DOORS_MAX )
				aut.A0( 80 );
			if ( flag && doorsPosition == 0 )
				aut.A0( 81 );
			flag = elevatorPosition != ELEVATOR_1_FLOOR && 
				   elevatorPosition != ELEVATOR_2_FLOOR && 
				   elevatorPosition != ELEVATOR_3_FLOOR;
			elevatorPosition += elevatorMove;
			if ( flag && ( elevatorPosition == ELEVATOR_1_FLOOR ||
						   elevatorPosition == ELEVATOR_2_FLOOR ||
						   elevatorPosition == ELEVATOR_3_FLOOR ))
				aut.A0( 60 );
			aut.A0( 0 );
			repaint();

			try
			{
				Thread.sleep( DELAY );
			}
			catch ( InterruptedException e )
			{
				break;
			}
		}
}

	/**
	 *    
	 */
	synchronized public void addEvent( int ev )
	{
		events.addElement( new Integer( ev ) );
	}

	/**
	 *    
	 */
	synchronized protected int getNextEvent()
	{
		int ev = 0;
		if ( !events.isEmpty() )
		{
			ev = ( (Integer)events.firstElement() ).intValue();
			events.removeElementAt( 0 );
		}
		return ev;
	}
	
	/**
	 *  :    
	 */
	public boolean x51()
	{
		log.input( 51, "   ", xx51 );
		return xx51;
	}

	/**
	 *  :   1 
	 */
	public boolean x61()
	{
		boolean ret = elevatorPosition == ELEVATOR_1_FLOOR;
		log.input( 61, "  1 ", ret );
		return ret;
	}
	
	/**
	 *  :   2 
	 */
	public boolean x62()
	{
		boolean ret = elevatorPosition == ELEVATOR_2_FLOOR;
		log.input( 62, "  2 ", ret );
		return ret;
	}
	
	/**
	 *  :   3 
	 */
	public boolean x63()
	{
		boolean ret = elevatorPosition == ELEVATOR_3_FLOOR;
		log.input( 63, "  3 ", ret );
		return ret;
	}
	
	/**
	 *  : 
	 *     ""   
	 */
	public void z110()
	{
		log.action( 110, 
			"    \"\"   " );
		zz11 = false;
	}
	
	/**
	 *  :
	 *     ""   
	 */
	public void z111()
	{
		log.action( 111, 
			"    \"\"   " );
		zz11 = true;
	}
	
	/**
	 *  : 
	 *     ""   
	 */
	public void z210()
	{
		log.action( 210, 
			"    \"\"   " );
		zz21 = false;
	}
	
	/**
	 *  : 
	 *     ""   
	 */
	public void z211()
	{
		log.action( 211, 
			"    \"\"   " );
		zz21 = true;
	}
	
	/**
	 *  : 
	 *     ""   
	 */
	public void z220()
	{
		log.action( 220, 
			"    \"\"   " );
		zz22 = false;
	}
	
	/**
	 *  : 
	 *     ""   
	 */
	public void z221()
	{
		log.action( 221, 
			"    \"\"   " );
		zz22 = true;
	}
	
	/**
	 *  : 
	 *     ""   
	 */
	public void z320()
	{
		log.action( 320, 
			"    \"\"   " );
		zz32 = false;
	}
	
	/**
	 *  : 
	 *     ""   
	 */
	public void z321()
	{
		log.action( 321, 
			"    \"\"   " );
		zz32 = true;
	}
	
	/**
	 *  :     "1"
	 */
	public void z400()
	{
		log.action( 400, "   \"1\"" );
		panelState = 0;
	}
	
	/**
	 *  :     "1"
	 */
	public void z411()
	{
		log.action( 411, "    \"1\"" );
		panelState = 1;
	}
	
	/**
	 *  :     "2"
	 */
	public void z421()
	{
		log.action( 421, "    \"2\"" );
		panelState = 2;
	}
	
	/**
	 *  :     "3"
	 */
	public void z431()
	{
		log.action( 431, "    \"3\"" );
		panelState = 3;
	}
	
	/**
	 *  :     "S"
	 */
	public void z441()
	{
		log.action( 441, "    \"S\"" );
		panelState = 4;
	}
	
	/**
	 *  :    
	 */
	public void z500()
	{
		log.action( 500, "   " );
		isLampOn = false;
	}
	
	/**
	 *  :    
	 */
	public void z501()
	{
		log.action( 501, "   " );
		isLampOn = true;
	}
	
	/**
	 *  :  
	 */
	public void z700()
	{
		log.action( 700, " " );
		elevatorMove = 0;
	}
	
	/**
	 *  :  
	 */
	public void z701()
	{
		log.action( 701, " " );
		elevatorMove = ELEVATOR_MOVE;
	}
	
	/**
	 *  :  
	 */
	public void z702()
	{
		log.action( 702, " " );
		elevatorMove = -ELEVATOR_MOVE;
	}
	
	/**
	 *  :   
	 */
	public void z800()
	{
		log.action( 800, "  " );
		doorsMove = 0;
	}
	
	/**
	 *  :  
	 */
	public void z801()
	{
		log.action( 801, " " );
		doorsMove = DOORS_MOVE;
	}
	
	/**
	 *  :  
	 */
	public void z802()
	{
		log.action( 802, " " );
		doorsMove = -DOORS_MOVE;
	}
	
	/**
	 *  :    
	 */
	public void z900()
	{
		log.action( 900, "   " );
		doorsTimer = -1;
	}
	
	/**
	 *  :    
	 */
	public void z901()
	{
		log.action( 901, "   " );
		doorsTimer = DOORS_TIMER_MAX;
	}	
}
